// LICENSE : MIT
"use strict";

var _textlintRuleHelper = require("textlint-rule-helper");

var _kuromojin = _interopRequireDefault(require("kuromojin"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function isTargetVerb(token) {
  return token.pos == "動詞" && token.conjugated_type == "一段";
}

function isReruWord(token) {
  return token.pos == "動詞" && token.pos_detail_1 == "接尾" && token.basic_form == "れる";
}

function isKoreru(token) {
  return token.pos == "動詞" && token.basic_form == "来れる";
}

module.exports = function (context) {
  var helper = new _textlintRuleHelper.RuleHelper(context);
  var Syntax = context.Syntax,
      report = context.report,
      getSource = context.getSource,
      RuleError = context.RuleError;
  return _defineProperty({}, Syntax.Str, function (node) {
    if (helper.isChildNode(node, [Syntax.Link, Syntax.Image, Syntax.BlockQuote, Syntax.Emphasis])) {
      return;
    }

    var text = getSource(node);
    return (0, _kuromojin.default)(text).then(function (tokens) {
      tokens.reduce(function (prev, current) {
        if (isTargetVerb(prev) && isReruWord(current)) {
          report(node, new RuleError("れ足す言葉を使用しています。", {
            index: current.word_position - 1
          }));
        }

        return current;
      });
    });
  });
};
//# sourceMappingURL=no-insert-re.js.map